package cz.fi.muni.pa165.entity;

import cz.fi.muni.pa165.entity.interfaces.Viewable;
import cz.fi.muni.pa165.enums.CountryEnum;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.ManyToMany;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import java.util.ArrayList;
import java.util.Set;

@Entity
public class TeamEntity extends BaseEntity implements Viewable {

    @Column(nullable = false, unique = true)
    private String name;
    private CountryEnum country;
    @OneToMany
    private Set<PlayerEntity> playerList;
    @ManyToMany
    private Set<TournamentEntity> completedTournaments;
    @ManyToMany
    private Set<TournamentEntity> plannedTournaments;
    @OneToOne
    private TeamManagerEntity manager;

    public TeamEntity(){

    }

    public TeamEntity(String name, TeamManagerEntity manager){
        this.name = name;
        this.manager = manager;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public CountryEnum getCountry() {
        return country;
    }

    public void setCountry(CountryEnum country) {
        this.country = country;
    }

    public Set<PlayerEntity> getPlayerList() {
        return playerList;
    }

    public void setPlayerList(Set<PlayerEntity> playerList) {
        this.playerList = playerList;
    }

    public Set<TournamentEntity> getCompletedTournaments() {
        return completedTournaments;
    }

    public void setCompletedTournaments(Set<TournamentEntity> completedTournaments) {
        this.completedTournaments = completedTournaments;
    }

    public Set<TournamentEntity> getPlannedTournaments() {
        return plannedTournaments;
    }

    public void setPlannedTournaments(Set<TournamentEntity> plannedTournaments) {
        this.plannedTournaments = plannedTournaments;
    }

    public void addPlayerToTheTeam(PlayerEntity newPlayer){
        this.playerList.add(newPlayer);
    }

    @Override
    public ArrayList<String> getInformation() {
        return null;
    }
}
