package cz.fi.muni.pa165.entity;

import cz.fi.muni.pa165.enums.CountryEnum;
import org.junit.jupiter.api.Test;
import org.testng.Assert;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import java.util.Date;

public class PersonEntityTest {

    private EntityManagerFactory emf = Persistence.createEntityManagerFactory("default");

    private Date BIRTH_DATE = new Date(1645568542000L);  // 22.2.2022  22:22:22

    @Test
    void saveRetrievePersonEntity() {
        PersonEntity person;
        EntityManager em = null;
        try {
            em = emf.createEntityManager();
            em.getTransaction().begin();
            person = new PersonEntity();
            person.setName("TestName");
            person.setCountry(CountryEnum.SLOVAKIA);
            person.setBirth(new Date(160));
            person.setBirth(BIRTH_DATE);
            em.persist(person);
            em.getTransaction().commit();
        } finally {
            if (em != null) em.close();
        }

        PersonEntity person1;
        EntityManager em1 = null;
        try {
            em1 = emf.createEntityManager();
            em1.getTransaction().begin();
            person1 = em1.find(PersonEntity.class, person.getId());
            em1.getTransaction().commit();
        } finally {
            if (em1 != null) em1.close();
        }
        Assert.assertEquals(person1.getBirth(), BIRTH_DATE);
        Assert.assertEquals(person1.getCountry(), CountryEnum.SLOVAKIA);
        Assert.assertEquals(person1.getName(), "TestName");
    }
}
